<template>
  <div class="counter">
    <div
      class="counter_item counter_item-day"
      v-if="days">
      <div class="counter-value">{{days}}</div>
      <div class="counter-label">{{$t('timer.day')}}</div>
    </div>
    <div class="counter_intraday">
      <div class="counter_item">
        <div class="counter-value">{{hours}}</div>
        <div class="counter-label">{{$t('timer.hour')}}</div>
      </div>
      <div>:</div>
      <div class="counter_item">
        <div class="counter-value">{{minutes}}</div>
        <div class="counter-label">{{$t('timer.min')}}</div>
      </div>
      <div>:</div>
      <div class="counter_item">
        <div class="counter-value">{{seconds}}</div>
        <div class="counter-label">{{$t('timer.sec')}}</div>
      </div>
    </div>
  </div>
</template>

<script>
  const MILLISECONDS_MINUTE = 60;
  const MILLISECONDS_HOUR = 60 * MILLISECONDS_MINUTE;
  const MILLISECONDS_DAY = 24 * MILLISECONDS_HOUR;

  export default {
    name: "TheCounter",
    props: {
      timestamp: {
        type: Number,
        default: () => new Date().getTime()
      }
    },
    data() {
      return {}
    },
    computed: {
      days() {
        let timeleft = Math.floor(this.timestamp / MILLISECONDS_DAY);
        if (timeleft > 0 && timeleft < 10) timeleft = `0${timeleft}`;
        return timeleft;
      },
      hours() {
        let timeleft = Math.floor(this.timestamp % MILLISECONDS_DAY / MILLISECONDS_HOUR);
        if (timeleft < 10) timeleft = `0${timeleft}`;
        return timeleft;
      },
      minutes() {
        let timeleft = Math.floor(this.timestamp % MILLISECONDS_HOUR / MILLISECONDS_MINUTE);
        if (timeleft < 10) timeleft = `0${timeleft}`;
        return timeleft;
      },
      seconds() {
        let timeleft = Math.floor(this.timestamp % MILLISECONDS_MINUTE);
        if (timeleft < 10) timeleft = `0${timeleft}`;
        return timeleft;
      }
    }
  }
</script>
<style
  lang="scss"
  scoped>
  .counter {
    display: flex;
    justify-content: space-between;
    color: #FFFFFF;
    letter-spacing: 1.4px;
    &_intraday {
      padding: 5px;
      display: flex;
      justify-content: center;
      flex: 1;
    }
    &_item {
      &-day {
        background-color: #273247;
        padding: 5px;
      }
    }
    &-value {
      font-size: .875rem;
    }
    &-label {
      color: #a09fa0;
      font-size: .465rem;
    }
  }
</style>
